#region Using declarations
using System;
using System.IO;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Indicator;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Strategy;
#endregion

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    /// <summary>
    /// Enter the description of your strategy here
    /// </summary>
    [Description("Enter the description of your strategy here")]
    public class SaveForTSlab : Strategy
    {
        #region Variables
		private bool flag=true;
		string str="";
		string path="";
		DateTime today;
		#endregion

        /// <summary>
        /// This method is used to configure the strategy and is called once before any strategy method is called.
        /// </summary>
        protected override void Initialize()
        {
            CalculateOnBarClose = false;
			System.Threading.Thread.CurrentThread.CurrentCulture = new System.Globalization.CultureInfo("en-US");
			flag=true;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			// Работаем только в режиме реального времени:
			if (Instrument == null) return;
			if(Historical) return;
			// первый запуск или первый тик новой торговой сесии
			if(flag || (Bars.FirstBarOfSession && FirstTickOfBar))
				{
					today = DateTime.Now;
					// создаем путь 
					//path=Environment.GetFolderPath(Environment.SpecialFolder.Personal)+"\\";
					path="D:\\Data_CME\\";
					
					// создаем имя файла
					string date=today.Year.ToString()+today.Month.ToString("00")+today.Day.ToString("00");
					path = path+Instrument.FullName+"_"+date+".txt";
					Print(path);
					// записываем шапку файла
					//str="<TICKER>,<PER>,<DATE>,<TIME>,<MSEC>,<LAST>,<VOL>,<ASK>,<BID>\r\n";
					str="<TICKER>,<PER>,<DATE>,<TIME>,<LAST>,<VOL>\r\n";
					File.WriteAllText(path,str);
					flag=false;
					//Print(str);
				}

			// тут отрабатываем каждый тик
			today = DateTime.Now;
			// "<TICKER>,<PER>,	
			str=Instrument.FullName+",0,";
			// <DATE>, 
			str = str + today.Year.ToString()+today.Month.ToString("00")+today.Day.ToString("00")+",";
			//<TIME>,
			str = str + today.Hour.ToString("00")+today.Minute.ToString("00")+today.Second.ToString("00")+",";
			//<MSEC>,
			//str = str + today.Millisecond.ToString("000")+",";	
			//<LAST>,
			str = str + Instrument.MasterInstrument.Round2TickSize(Close[0]).ToString()+",";
			//<VOL>,
			str = str + Volume[0] + "\r\n";
			//<ASK>,
			//str = str + GetCurrentAsk() + ",";	
			//<BID>,
			//str = str + GetCurrentBid()+"\r\n";
			//
			//double currentAskVolume = GetCurrentAskVolume();
			//double currentBidVolume = GetCurrentBidVolume();
			//Print( str );
			File.AppendAllText(path,str);

        }
    }
}